#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "k": 5,
    "swap": 0,
    "maxw": 10**4,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():

    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    k = int(cmdlinearg("k"))
    swap = int(cmdlinearg("swap"))
    MAXW = int(cmdlinearg("maxw"))

    weights = [0] * n
    edges = []

    weights[0] = random.randint(1, MAXW)
    weights[n-1] = random.randint(1, MAXW)

    w1 = random.randint(1, MAXW // 2)
    w2 = random.randint(1, MAXW // 2)

    for i in range(1, n-3):
        edges.append((0, i))
        edges.append((i, n-3))
        weights[i] = w1
    edges.append((0, n-2))
    edges.append((n-2, n-1))
    edges.append((n-3, n-1))

    weights[n-3] = w2
    weights[n-2] = w1+w2

    if swap:
        weights = weights[::-1]

    print(n, len(edges), k)
    print(*weights)
    for u, v in edges:
        if swap:
            print(n-u, n-v)
        else:
            print(u+1, v+1)


    
if __name__ == "__main__":
    main()