#!/bin/bash
USE_SCORING=0
. ../testdata_tools/gen.sh

# ulimit -s unlimited

use_solution nils.cpp

compile gen_random.py
compile gen_dense.py
compile gen_source.py
compile gen_anti_forgotten.py

MAXN=100000
MAXM=200000
MAXW=10000

sample_manual 1
sample_manual 2
sample_manual 3

tc small-01 gen_random n=5 m=10 k=2 w=1
tc small-02 gen_random n=10 m=20 k=5 w=1 only_shortest=1
tc small-03 gen_random n=2 m=1 k=2
tc small-04 gen_random n=2 m=1 k=1
tc small-05 gen_random n=50 m=100 k=25 w=10 only_shortest=1

tc medium-06 gen_random n=100 m=99 k=50 w=1
tc medium-07 gen_random n=200 m=400 k=100 w=1
tc medium-08 gen_random n=400 m=2000 k=50 w=1
tc medium-09 gen_random n=800 m=1600 k=400
tc medium-10 gen_random n=1601 m=3500 k=800 w=20 only_shortest=1

tc large-11 gen_random n=10000 m=9999 k=500 w=1
tc large-12 gen_random n=10000 m=20000 k=5000
tc large-13 gen_random n=$MAXN m=$MAXM k=$(($MAXN / 2))
tc large-14 gen_random n=$MAXN m=$MAXM k=$(($MAXN / 2)) w=1 only_shortest=1
tc large-15 gen_random n=$MAXN m=$MAXM k=$(($MAXN / 2)) w=10 only_shortest=1
tc large-16 gen_random n=$MAXN m=$MAXM k=1

tc dense-17 gen_dense n=10 a=1 b=1 c=5
tc dense-18 gen_dense n=10 a=1 b=1 c=5 special=1
tc dense-19 gen_dense n=100 a=20 b=20 c=40
tc dense-20 gen_dense n=10000 a=3000 b=3000 c=3300
tc dense-21 gen_dense n=$MAXN a=$(($MAXN / 4)) b=$(($MAXN / 4)) c=$(($MAXN / 3))
tc dense-22 gen_dense n=$MAXN a=$(($MAXN / 4)) b=$(($MAXN / 4)) c=$(($MAXN / 3)) special=1
tc dense-23 gen_dense n=$MAXN a=$(($MAXN / 3)) b=$(($MAXN / 3)) c=$(($MAXN / 4))

tc_manual ../manual_tests/ab-triangle2.in
tc_manual ../manual_tests/ab-triangle1.in

tc source-26 gen_source n=10 k=5 d=5
tc source-27 gen_source n=10 k=5 d=5 swap=1
tc source-28 gen_source n=1000 k=500 d=500
tc source-29 gen_source n=$MAXN k=$(($MAXN / 2)) d=$(($MAXN / 2))
tc source-30 gen_source n=$MAXN k=$(($MAXN / 2)) d=$(($MAXN / 2)) swap=1
tc source-31 gen_source n=$MAXN k=$(($MAXN / 2)) d=$((7 * $MAXN / 10))
tc source-32 gen_source n=$MAXN k=$(($MAXN / 2)) d=$((9 * $MAXN / 10)) swap=1
tc source-33 gen_source n=$MAXN k=$MAXN d=$((7 * $MAXN / 10))

tc antiforgotten-34 gen_anti_forgotten n=$MAXN k=$(($MAXN / 2))
tc antiforgotten-35 gen_anti_forgotten n=$MAXN k=$(($MAXN / 2)) swap=1
