#!/usr/bin/python3

import sys
import random

default = {
    "n": 10,
    "max_d": 10**9,
    "part_size": 10**6,
}

def cmdlinearg(name):
    for arg in sys.argv:
        if arg.startswith(name + "="):
            return arg.split("=")[1]
    return default[name]

def main():
    random.seed(int(sys.argv[-1]))
    n = int(cmdlinearg("n"))
    max_d = int(cmdlinearg("max_d"))
    part_size = int(cmdlinearg("part_size"))

    nums = [random.randrange(0, max_d+1) for _ in range(min(n, part_size))]

    a = [nums[i%len(nums)] for i in range(n)]
    random.shuffle(nums)
    b = [nums[i%len(nums)] for i in range(n)]

    # Pad with zeros in case part_size not a divisor of n
    for i in range(n%part_size):
        a[n-i-1] = 0
        b[n-i-1] = 0

    print(n)
    print(*a)
    print(*b)

    
    
if __name__ == "__main__":
    main()